diff --git a/player/audio.c b/player/audio.c
index 06ea1262a65f..051a28f85da9 100644
--- a/player/audio.c
+++ b/player/audio.c
@@ -945,6 +945,7 @@ void fill_audio_out_buffers(struct MPContext *mpctx)
                           (opts->gapless_audio && !ao_untimed(ao_c->ao))))
         {
             MP_VERBOSE(mpctx, "audio EOF reached\n");
+            ao_drain(mpctx->ao);
             mpctx->audio_status = STATUS_EOF;
             mp_wakeup_core(mpctx);
         }
